package cn.com.qmth.examcloud.core.examwork.service.cache;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.core.examwork.service.ExamService;
import cn.com.qmth.examcloud.support.cache.bean.ExamStudentPropertyCacheBean;
import cn.com.qmth.examcloud.web.cache.RandomObjectRedisCache;

@Service
public class ExamStudentPropertyCache extends RandomObjectRedisCache<ExamStudentPropertyCacheBean> {

	@Autowired
	private ExamService examService;

	@Override
	public ExamStudentPropertyCacheBean loadFromResource(Object... keys) {
		Long examId = (Long) keys[0];
		Long studentId = (Long) keys[1];
		String key = (String) keys[2];

		String value = examService.getExamStudentProperty(examId, studentId, key);

		ExamStudentPropertyCacheBean b = new ExamStudentPropertyCacheBean();
		b.setExamId(examId);
		b.setStudentId(studentId);
		b.setKey(key);
		b.setValue(value);
		return b;
	}

	@Override
	protected String getKeyPrefix() {
		return "E_EXAM_STUDENT_PROP:";
	}

	@Override
	protected int getTimeout() {
		// 2分钟
		return 60 * 2;
	}

}
